<!-- 要求、委托书及合同评审表列表 -->
<script name="ExamineList" lang="ts" setup>
import { ElMessage, ElMessageBox, dayjs } from 'element-plus'
import type { DateModelType } from 'element-plus'
import type{ ICustomerExamineInfo, IListQuery } from './customer-examine'
import type { TableColumn } from '@/components/NormalTable/table_interface'
import type { IMenu } from '@/components/buttonBox/buttonBox'
import type { IDictType } from '@/commonInterface/resource-interface'
import { deleteExamineDraft, deleteExamineRevoked, getExamineList, refuseApproval, revokeApproval } from '@/api/resource/examine'
import { getDictByCode } from '@/api/system/dict'
import ApprovalDialog from '@/views/resource/common/approvalDialog.vue'

// 定义常量
const buttonBoxActive = 'examineApproval' // 存储在sessionstorage里面的字段名，用于记录右上角buttonbox点击状态
const flowFormId = 'zyglyqwtsjhtpsb' // 资源管理 - 要求、委托书及合同评审表

const { proxy } = getCurrentInstance() as any
const router = useRouter()

// 选中的审批状态按钮
const active = ref('')
const menu = ref<IMenu[]>([]) // 审批状态按钮组合
const approvalStatusList = ref<String[]>([
  '全部', '已审批', '待审批', '审批', '草稿箱', '审批中', '已通过', '未通过', '已取消',
])

// 弹窗子组件
const apprDial = ref()

// 查询条件
const searchQuery = ref<IListQuery>({
  formNo: '', // 通知单编号
  labCode: '',
  groupCode: '',
  createUserName: '', // 创建人名字
  createTimeStart: '', // 创建时间-起始
  createTimeEnd: '', // 创建时间-结束
  approvalStatus: active.value, // 审批状态
  formId: flowFormId, // 表单id（流程定义对应的表单id，等价于业务id），此处为固定值
  offset: 1,
  limit: 20,
})
const dateRange = ref<[DateModelType, DateModelType]>(['', ''])// 筛选时间段数据
const total = ref(0) // 数据条数
const loadingTable = ref(false) // 表格loading

// 表头
const columns = ref<TableColumn[]>([
  { text: '评审表编号', value: 'formNo', align: 'center', width: '200' },
  { text: '实验室代码', value: 'labCodeName', align: 'center' },
  { text: '组别代码', value: 'groupCodeName', align: 'center' },
  { text: '委托方签字情况', value: 'signStatusName', align: 'center' },
  { text: '创建人', value: 'createUserName', align: 'center', width: '150' },
  { text: '创建时间', value: 'createTime', align: 'center', width: '180' },
])
const examineList = ref<Array<ICustomerExamineInfo>>([]) // 表格数据

// 字典值
const labCodeDict = ref<IDictType[]>([])
const groupCodeDict = ref<IDictType[]>([])

const reset = () => {
  searchQuery.value = {
    formNo: '', // 委托方编号
    labCode: '',
    groupCode: '',
    createUserName: '',
    createTimeStart: '', // 创建时间-起始
    createTimeEnd: '', // 创建时间-结束
    approvalStatus: active.value, // 审批状态
    formId: flowFormId, // 表单id（流程定义对应的表单id，等价于业务id），此处为固定值
    offset: 1,
    limit: 20,
  }
  dateRange.value = ['', '']
  fetchData(true)
}

const searchList = () => {
  fetchData(true)
}

// 数据查询
function fetchData(isNowPage = false) {
  loadingTable.value = true
  if (!isNowPage) {
    // 是否显示当前页，否则跳转第一页
    searchQuery.value.offset = 1
  }
  getExamineList(searchQuery.value).then((response) => {
    if (response.code === 200) {
      examineList.value = response.data.rows

      total.value = parseInt(response.data.total)
    }
    loadingTable.value = false
  }).catch(() => {
    loadingTable.value = false
  })
}

// 页数发生变化后的操作，可能是页码变化，可能是每页容量变化，此函数必写
const changePage = (val: { size?: number; page?: number }) => {
  if (val && val.size) {
    searchQuery.value.limit = val.size
  }
  if (val && val.page) {
    searchQuery.value.offset = val.page
  }
  fetchData(true)
}

const addExamine = () => {
  router.push({
    query: {
      type: 'create',
    },
    path: 'examine/detail',
  })
}

const detail = (row: ICustomerExamineInfo) => {
  if (active.value === '0') {
    // 全部时 查看和打印文件流
    router.push({
      query: {
        id: row.id,
      },
      path: 'examine/approved/detail',
    })
  }
  else if (active.value === '1') {
    // 草稿箱 状态下的查看 可以编辑
    sessionStorage.setItem('examineInfo', JSON.stringify(row))
    router.push({
      query: {
        type: 'update',
        id: row.id,
        status: active.value,
      },
      path: 'examine/detail',
    })
  }
  else {
    sessionStorage.setItem('examineInfo', JSON.stringify(row))
    router.push({
      query: {
        type: 'detail',
        id: row.id,
        status: active.value,
      },
      path: 'examine/detail',
    })
  }
}

// 删除
const deleteSuggestById = (row: ICustomerExamineInfo) => {
  ElMessageBox.confirm(
    `确认删除评审表 ${row.formNo} 吗？`,
    '提示',
    {
      confirmButtonText: '确认',
      cancelButtonText: '取消',
      type: 'warning',
    },
  ).then(() => {
    if (active.value === '1') {
      // 草稿箱 中删除
      deleteExamineDraft({ id: row.id }).then((res) => {
        if (res.code === 200) {
          ElMessage.success(`评审表 ${row.formNo} 删除成功`)
          fetchData(true)
        }
        else {
          ElMessage.error(`评审表 ${row.formNo} 删除失败：${res.message}`)
        }
      })
    }
    else if (active.value === '6') {
      // 已取消 中删除
      deleteExamineRevoked({ id: row.id }).then((res) => {
        if (res.code === 200) {
          ElMessage.success(`评审表 ${row.formNo} 删除成功`)
          fetchData(true)
        }
        else {
          ElMessage.error(`评审表 ${row.formNo} 删除失败：${res.message}`)
        }
      })
    }
  })
}

// 审批按钮点击切换事件
const changeCurrentButton = (val: string) => {
  active.value = val // 此时的tab
  sessionStorage.setItem(buttonBoxActive, val) // 记录tab状态

  reset() // 刷新
}

// 流程审批-同意
const approvalAgreeHandler = (row: ICustomerExamineInfo) => {
  apprDial.value.initDialog('agree', row.id, row.taskId, '')
}

// 流程审批-拒绝
const approvalRefuseHandler = (row: ICustomerExamineInfo) => {
  apprDial.value.initDialog('refuse', row.id, row.taskId, '')
}

// 取消（撤回审批单）
const revokeApprById = (row: ICustomerExamineInfo) => {
  apprDial.value.initDialog('revoke', row.id, row.taskId, row.processId)
}

// 流程操作之后刷新
const afterApprovalHandler = () => {
  fetchData(true)
}

// 取消
const noteRevokeHandler = (param: any) => {
  revokeApproval(param).then((res) => {
    if (res.code === 200) {
      ElMessage.success('流程取消成功')
    }
    else {
      ElMessage.error(`流程取消失败：${res.message}`)
    }
    // 关闭弹窗
    apprDial.value.handleClose()

    fetchData(true)
  })
}

// 拒绝
const noteRefuseHandler = (param: any) => {
  refuseApproval(param).then((res) => {
    if (res.code === 200) {
      ElMessage.success('拒绝审批完成')
    }
    else {
      ElMessage.error(`拒绝审批失败：${res.message}`)
    }
    // 关闭弹窗
    apprDial.value.handleClose()

    fetchData(true)
  })
}

// 初始化流程审批状态按钮
const getApprovalStatusDict = async () => {
  await getDictByCode('approvalStatus').then((res) => {
    if (res.code === 200) {
      approvalStatusList.value.forEach((item) => {
        const tempFindData = res.data.find((e: { name: string; value: string }) => e.name === item)
        if (tempFindData) {
          menu.value.push({
            name: tempFindData.name,
            id: `${tempFindData.value}`,
          })
        }
      })
    }
  })
}

const getLabCodeDict = async () => {
  await getDictByCode('bizLabCode').then((res) => {
    if (res.code === 200) {
      labCodeDict.value = res.data
    }
  })
}

const getGroupCodeDict = async () => {
  await getDictByCode('bizGroupCode').then((res) => {
    if (res.code === 200) {
      groupCodeDict.value = res.data
    }
  })
}

const getDict = async () => {
  await getApprovalStatusDict()
  await getLabCodeDict()
  await getGroupCodeDict()
}

watch(dateRange, (val) => {
  if (val) {
    searchQuery.value.createTimeStart = dayjs(val[0]).format('YYYY-MM-DD') === 'Invalid Date' ? '' : dayjs(val[0]).format('YYYY-MM-DD')
    searchQuery.value.createTimeEnd = dayjs(val[1]).format('YYYY-MM-DD') === 'Invalid Date' ? '' : dayjs(val[1]).format('YYYY-MM-DD')
  }
  else {
    searchQuery.value.createTimeStart = ''
    searchQuery.value.createTimeEnd = ''
  }
})

onMounted(async () => {
  await getDict()
  if (sessionStorage.getItem(buttonBoxActive) !== undefined && sessionStorage.getItem(buttonBoxActive) !== null) {
    active.value = sessionStorage.getItem(buttonBoxActive)!
  }
  else {
    active.value = '0' // 全部
  }
})
</script>

<template>
  <app-container>
    <!-- 筛选条件 -->
    <search-area :need-clear="true" @search="searchList" @clear="reset">
      <search-item>
        <el-input v-model="searchQuery.formNo" placeholder="登记表编号" clearable />
      </search-item>
      <search-item>
        <el-select v-model="searchQuery.labCode" placeholder="实验室代码" clearable>
          <el-option v-for="dict in labCodeDict" :key="dict.id" :value="dict.value" :label="dict.name" />
        </el-select>
      </search-item>
      <search-item>
        <el-select v-model="searchQuery.groupCode" placeholder="组别代码" clearable>
          <el-option v-for="dict in groupCodeDict" :key="dict.id" :value="dict.value" :label="dict.name" />
        </el-select>
      </search-item>
      <search-item>
        <el-input v-model="searchQuery.createUserName" placeholder="创建人" clearable />
      </search-item>
      <search-item>
        <el-date-picker v-model="dateRange" type="daterange" start-placeholder="创建时间（开始）" end-placeholder="创建时间（结束）" />
      </search-item>
    </search-area>

    <!-- 表格数据展示 -->
    <table-container>
      <!-- 表头区域 -->
      <template #btns-right>
        <icon-button v-if="proxy.hasPerm('/resource/customer/examine/add') && active === '0'" icon="icon-add" title="新建" @click="addExamine" />
      </template>

      <!-- 表格区域 -->
      <normal-table
        :data="examineList" :total="total" :columns="columns"
        :query="{ limit: searchQuery.limit, offset: searchQuery.offset }"
        :list-loading="loadingTable"
        @change="changePage"
      >
        <template #preColumns>
          <el-table-column label="序号" width="55" align="center">
            <template #default="scope">
              {{ (searchQuery.offset - 1) * searchQuery.limit + scope.$index + 1 }}
            </template>
          </el-table-column>
        </template>
        <template #columns>
          <el-table-column fixed="right" label="操作" align="center" width="130">
            <template #default="{ row }">
              <el-button v-if="active === '0'" size="small" type="primary" link @click="detail(row)">
                查看
              </el-button>

              <el-button v-else size="small" type="primary" link @click="detail(row)">
                查看
              </el-button>

              <el-button v-if="(active === '1' || active === '6') && proxy.hasPerm(`/resource/customer/examine/del`)" size="small" type="danger" link @click="deleteSuggestById(row)">
                删除
              </el-button>

              <template v-if="active === '2'">
                <el-button size="small" type="primary" link @click="approvalAgreeHandler(row)">
                  同意
                </el-button>
                <el-button size="small" type="danger" link @click="approvalRefuseHandler(row)">
                  拒绝
                </el-button>
              </template>
              <template v-if="active === '3'">
                <el-button size="small" type="info" link @click="revokeApprById(row)">
                  取消
                </el-button>
              </template>
            </template>
          </el-table-column>
        </template>
      </normal-table>
    </table-container>

    <!-- 审批单弹窗 -->
    <approval-dialog
      ref="apprDial"
      @on-success="afterApprovalHandler"
      @on-refuse="noteRefuseHandler"
      @on-revoke="noteRevokeHandler"
    />

    <!-- 右上角按钮集合 -->
    <button-box :active="active" :menu="menu" @change-current-button="changeCurrentButton" />
  </app-container>
</template>
